import processing.sound.*;

SinOsc[] sineWaves;
int numSines = 3; 
float[] sineVolume;

int trigger;
// Sample sur texte
// Ce script permet de charge des sample en aiff ou mp3 
// et un texte sous forme brute (txt)
// d'analyse le texte 
// en connaitre le nombre de mots, de phrases, 
// savoir combien de fois chaque mot est utilisé
// et passer en revue le texte mot par mot 
// ou phrase par phrase
// et de déclencher des sons en fonction d'un test.
texte montexte;

// donner le nom des éléments à charger
String s="madame_bovary.txt"; // nom du texte
int vitesse=100;

void setup() {
  size(600, 600);
  textAlign(CENTER);
  // charger les fichiers mp3 ou aif dans "liste"
  
   // Create the oscillators and amplitudes
  sineWaves = new SinOsc[numSines];
  sineVolume = new float[numSines]; 
  for (int i = 0; i < numSines; i++) {

    // The overall amplitude shouldn't exceed 1.0 which is prevented by 1.0/numSines.
    // The ascending waves will get lower in volume the higher the frequency
    sineVolume[i] = (1.0 / numSines) / (i + 1);

    // Create the Sine Oscillators and start them
    sineWaves[i] = new SinOsc(this);
    sineWaves[i].play();
  }
  
  montexte=new texte(s);

  // quelques infos sur le texte analysé
  println("Dans le texte "+s);
  println("nombre de mots: "+montexte.nombre_mots);
  println("nombre de phrases: "+montexte.nombre_phrases);
  println("nombre de mots dans l'inventaire : "+montexte.inventaire.size());
  println("Mot le plus employé : -"+montexte.tri_mot[0]+"- "+montexte.tri_occurence[0]+ " fois");
  trigger = millis();
}

void draw() {
  if (millis() > trigger) {
    background(0);
    fill(255);

    //montexte.mot_suivant();
    montexte.mot_suivant();
    //montexte.mot
    //montexte.phrase
    // montexte.mots_phrase
    
    
        float detune = float(mouseX) / width - 0.5;
    float lum=1; //map(i.luminosite, 0, 255, -0.5, 0.5);
    float[] frequency=new float[3];
    
    // frequence sur le nombre de lettres dans la phrase
    frequency[0]= pow(1000, map(montexte.phrase.length(), 0, 500, 0, 0.6)) + 150;
    
    // frequence sur la longueur du mot courant
    frequency[1]= pow(1000, map(montexte.mot.length(), 0, 60, 1.0, 0)) + 150;
    
    // fequence sur le nombre de mots dans la phrase
    frequency[2]= pow(1000, map(montexte.mots_phrase.length, 0, 60, 0, 1.0)) + 150;

    for (int i = 0; i < numSines; i++) { 
      sineWaves[i].freq(frequency[i] * (i + 1 + i * lum));
      sineWaves[i].amp(sineVolume[i]);
    }
    
    
    affiche_stats();
    trigger = millis() + vitesse;
  }
}